#!/usr/bin/perl
# Author: Alex Efros <powerman@consultant.com>
# Desc -- Process template wroten in "iCGI" style - break usual CGI to 2 
#     pieces of code: "logic" and "interface".
# Idea -- take "interface" code from HTML-template, process it in 
#     eperl-style and output it.
#
package POWER::iCGI_filter;
use Filter::Simple;
use strict;
our $VERSION = v0.0.1;

FILTER {
    use Data::Dumper;
    warn "ENTER IN FILTER(".length."): ".Dumper($_);
    my $e = "package ".caller(1)."; no strict; local (\$^W) = 0 ;\n";
    while ( 1 ) {
	warn "..... IN FILTER(".length($e).")";
        /\G<!--&(.*?)-->/gcs       && do { $e.="\n$1\n;\n" }
     || /\G@~(.*?)~@/gcs       && do { $e.="\$${\__PACKAGE__}::__ .= POWER::lib::Enc(do { $1; }) ;" }
     || /\G#~(.*?)~#/gcs       && do { $e.="\$${\__PACKAGE__}::__ .= do { $1; } ;" }
     || /\G\^~(.*?)~\^/gcs         && do { $e.="\$${\__PACKAGE__}::__ .= POWER::lib::EncUri(do { $1; }) ;" }
     || /\G(.+?)(?=<!--&|@~|#~|\^~|$)/gcs && do { $e.="\$${\__PACKAGE__}::__ .= \"\Q$1\E\";" }
#        s/\G<!--&(.*?)-->/\n$1\n;\n/gcs
#     || s/\G@~(.*?)~@/\$${\__PACKAGE__}::__ .= POWER::lib::Enc(do { $1; }) ;/gcs
#     || s/\G#~(.*?)~#/\$${\__PACKAGE__}::__ .= do { $1; } ;/gcs
#     || s/\G\^~(.*?)~\^/\$${\__PACKAGE__}::__ .= POWER::lib::EncUri(do { $1; }) ;/gcs
#     || s/\G(.+?)(?=<!--&|@~|#~|\^~|$)/\$${\__PACKAGE__}::__ .= "\Q$1\E";/gcs
     || last;
    }
    $_ = $e;
    warn "LEAVE FILTER(".length."): ".Dumper($_);
};

1;
